#ifndef __vsprogress_h__
#define __vsprogress_h__
/****************************************************************************/
/** vsprogress.h                                                           **/
/** ---------------------------------------------------------------------- **/
/** Virutualizes old style scheme                                          **/
/** ---------------------------------------------------------------------- **/
/** ---------------------------------------------------------------------- **/
/** December 30, 1998 by Oleg Kagan                                        **/
/****************************************************************************/

//============================================================================
#include "vscbscheme.h"

// TProgressProcessor
//============================================================================
class TProgressProcessor {
public:
	//------------------------------------------------------------------------
	TProgressProcessor() : p_fnCallback(0) {}
	//------------------------------------------------------------------------
	virtual ~TProgressProcessor();

	//------------------------------------------------------------------------
	TProgressCallbackPtr Callback();

	//------------------------------------------------------------------------
	virtual void operator()(int) = 0;

private:
	//------------------------------------------------------------------------
	TProgressCallbackPtr p_fnCallback;
} /*TProgressProcessor*/;

//============================================================================
inline void ProcessScheme(

	TProgressProcessor& r_Processor
	
){
	ProcessScheme(r_Processor.Callback());
} /*ProcessScheme(TProgressProcessor&)*/

#endif /*!defined(__vsprogress_h__)*/